#CCASAnet data
#FirstWave analysis
#This code prepares analysis dataset for CCASAnet data
#Giganti
#Start Date:  03JUN2014

#Modification for DataSim -- 01APR2016

#Current run time:  ~10 minutes

require(plyr)



    #source('~/Documents/CCASAnet/FirstWave/CCASAnet ADE definition R code.R', chdir = FALSE)
    setwd("~/Dropbox/datasim/first-wave")
    source('CCASAnet ADE definition R code.R', chdir = FALSE)
    #load("/Users/giganti/Documents/CCASAnet/FirstWave/CCASAnetAIDSstatus.Rda")


#Set Freeze date for initiation - this is a 10 year analysis!
	FreezeDate<-as.Date('2004-01-01')
#Set earliest possible ART start date - HAART didn't exist before 1996!
	EarliestARTDate<-as.Date('1996-01-01')

#Import data
# 	basic<-read.csv("/Users/giganti/Documents/CCASAnet/Data/basic.csv",header=T)
# 	art<-read.csv("/Users/giganti/Documents/CCASAnet/Data/art.csv",header=T)
# 	follow<-read.csv("/Users/giganti/Documents/CCASAnet/Data/follow.csv",header=T)
# 	visit<-read.csv("/Users/giganti/Documents/CCASAnet/Data/visit.csv",header=T)
# 	lab_cd4<-read.csv("/Users/giganti/Documents/CCASAnet/Data/lab_cd4.csv",header=T)
# 	lab_rna<-read.csv("/Users/giganti/Documents/CCASAnet/Data/lab_rna.csv",header=T)
    basic<-read.csv("../output/basic_sim.csv",header=T)
    art<-read.csv("../output/art_sim.csv",header=T)
    follow<-read.csv("../output/follow_sim.csv",header=T)
    visit<-read.csv("../output/visit_sim.csv",header=T)
    lab_cd4<-read.csv("../output/lab_cd4_sim.csv",header=T)
    lab_rna<-read.csv("../output/lab_rna_sim.csv",header=T)


#Function to rename patient ID variable
SitePatientID<-function(df){
    df$site.patient<-df$patient
}
#Create unique patient ID for each data table
	basic$site.patient<-SitePatientID(basic)
	art$site.patient<-SitePatientID(art)
	follow$site.patient<-SitePatientID(follow)
	lab_cd4$site.patient<-SitePatientID(lab_cd4)
	visit$site.patient<-SitePatientID(visit)
	lab_rna$site.patient<-SitePatientID(lab_rna)
	AIDSstatus$site.patient<-SitePatientID(AIDSstatus)
#Date reformatting
    basic$birth_dt<-as.Date(basic$birth_d)
    #Reformat other dates from different data tables
    art$startdate<-as.Date(art$art_sd)
    art$enddate<-as.Date(art$art_ed)
    #basic$birth_dt<-as.Date(basic$birth_d)
    basic$baseline_dt<-as.Date(basic$baseline_d)
    follow$lastalive_dt<-as.Date(follow$l_alive_d)
    lab_cd4$cd4_dt<-as.Date(lab_cd4$cd4_d)
    lab_rna$rna_dt<-as.Date(lab_rna$rna_d)
    visit$visit_dt<-as.Date(visit$visit_d)


    #Workaround to create date variable
    #Problem because first observation is ""
    temp_aids_dt<-ifelse(basic$aids_d=="","1900-01-01",as.character(basic$aids_d))
    temp_aids_dt<-as.Date(temp_aids_dt)
    basic$aids_dt<-ifelse(temp_aids_dt=="1900-01-01",NA,temp_aids_dt)
    temp_aids_dt<-NULL
    
    temp_aids_cl_dt<-ifelse(basic$aids_cl_d=="","1900-01-01",as.character(basic$aids_cl_d))
    temp_aids_cl_dt<-as.Date(temp_aids_cl_dt)
    basic$aids_cl_dt<-ifelse(temp_aids_cl_dt=="1900-01-01",NA,temp_aids_cl_dt)
    temp_aids_cl_dt<-NULL
                  
    temp_death_dt<-ifelse(follow$death_d=="","1900-01-01",as.character(follow$death_d))
    temp_death_dt<-as.Date(temp_death_dt)
    follow$death_dt<-ifelse(temp_death_dt=="1900-01-01",NA,temp_death_dt)
    temp_death_dt<-NULL

   

###############
#Follow Dataset
###############
#Creating analysis variables
#Censor date
	follow$death_dt<-ifelse(follow$death_dt=="1900-01-01",NA, follow$death_dt)
	follow$censor_dt<-ifelse(follow$death_y==1 & is.na(follow$death_dt)==F, follow$death_dt,follow$lastalive_dt)
	follow$censor_dt<-as.Date(follow$censor_dt,origin="1970-01-01")
#Event - yes=1, no=0
#Use death_y variable



#Create truncated dataset to merge later
	follow.short<-follow[,c("site.patient","death_y","censor_dt")]



#WTD: This code takes the max of death_y.  This code,however, does not check to see if the last active date is after the death date.  Caution.
	follow.short<-ddply(follow.short,.(site.patient), summarize, censor_dt=max(censor_dt),death_y=max(death_y))
	
#####################################################################################################
#####################################################################################################



###########
##ART
###########
	art<-with(art,art[order(site.patient,startdate,enddate),])

	ARV1<- substr(art$art_id,1,3)
	ARV2<- substr(art$art_id,5,7)
	ARV3<- substr(art$art_id,9,11)
	ARV4<- substr(art$art_id,13,15)
	ARV5<- substr(art$art_id,17,19)
	ARV6<- substr(art$art_id,21,23)
	ARV7<- substr(art$art_id,25,27)
	ARV8<- substr(art$art_id,29,31)

	ARVs<-cbind(ARV1,ARV2,ARV3,ARV4,ARV5,ARV6,ARV7,ARV8)
	NRTI<-PI<-NNRTI<-EI<-FI<-II<-OTHER<-rep(0,length(art$art_id))

	for (i in 1:8){
	    NRTI<-ifelse (ARVs[,i] %in% c("3TC","ABC","AZT","D4T","DDC","DDI","FTC","TDF"), NRTI+1,NRTI)
	    PI<-ifelse (ARVs[,i] %in% c("APV","ATV","DRV","FPV","IDV","NFV","LPV","SQV","TPV"),PI+1,
	    ifelse (ARVs[,i] %in% c("RTV"),PI+0.5,PI))
	    NNRTI<-ifelse (ARVs[,i] %in% c("DLV","EFV","ETV","NVP","RPV","ETR","CAP"),NNRTI+1,NNRTI)
	    EI<-ifelse (ARVs[,i] %in% c("MRV","MVC"),EI+1,
	    ifelse(ARVs[,i] %in% c("PBO"),EI,
	    EI))
	    FI<-ifelse (ARVs[,i] %in% c("T20","ENF"),FI+1,FI)
	    II<-ifelse (ARVs[,i] %in% c("DTG","EVG","RGV","RAL"),II+1,II)
	    OTHER<-ifelse (ARVs[,i] %in% c("VIC"),OTHER+1,OTHER)
	}
	OTHER<-EI+FI+II+OTHER


	OneMat<-data.frame(NRTI=NRTI, NNRTI=NNRTI,PI=PI,OTHER=OTHER)
	OneMat$ClassCount<-with(OneMat,paste(NRTI,"-",NNRTI,"-",PI,"-",OTHER,sep=""))


    #source('~/Documents/CCASAnet/FirstWave/ARV reclassification R code.R', chdir = FALSE)
    source('ARV reclassification R code.R', chdir = FALSE)
    art$regimen<-ARVreclassification(OneMat)



#Goal:  Find ART start date
#Strategy: Restrict dataset to just first ART observation
	art<-cbind(art,OneMat)
	art_temp <- ddply(art, .(site.patient), summarize,FirstARTdate=min(startdate))
	art_temp<-merge(art_temp,art,by.x=c("site.patient","FirstARTdate"),by.y=c("site.patient","startdate"),all.x=T)
	Artstartdate<-art_temp[,c("site.patient","FirstARTdate","regimen","NRTI","NNRTI","PI","OTHER","art_id","art_rs")]
	names(Artstartdate)<-c("site.patient","FirstARTdate","ARVclass","NRTI","NNRTI","PI","OTHER","FirstART","StopReason")


	Artstartdate$ARVclass<-toupper(Artstartdate$ARVclass)
	Artstartdate$ARVclass<-with(Artstartdate, as.factor(ifelse(ARVclass=="NNRTI","NNRTI",
														ifelse(ARVclass=="BOOSTED PI","BOOSTED PI",
														ifelse(ARVclass=="3 NRTI","3 NRTI",
														ifelse(ARVclass=="UNBOOSTED PI","UNBOOSTED PI",
														ifelse(ARVclass=="PI","UNBOOSTED PI",
														ifelse(ARVclass=="OTHER","OTHER",
														ifelse(ARVclass %in% c("NONHAART","NON HAART","NON-HAART"),"nonHAART",
														NA)))))))))

	#Add first start date to art
	art<-merge(art,Artstartdate,by.x=c("site.patient"),by.y=c("site.patient"))




########################################################
#In this particular analysis, we are interested in time since HAART initiation specifically
#Thus, we want to start the clock at time of HAART
#Below, we generate a variable
#Will want to classify patients who start nonHAART as non-naive
########################################################
	art_HAARTonly<-art[art$regimen!="non-HAART",]
	HAART_temp <- ddply(art_HAARTonly, .(site.patient), summarize,FirstHAARTdate=min(startdate))
	HAART_temp<-merge(HAART_temp,art_HAARTonly,by.x=c("site.patient","FirstHAARTdate"),by.y=c("site.patient","startdate"),all.x=T)
	HAARTstartdate<-HAART_temp[,c("site.patient","FirstHAARTdate","regimen","art_id")]
	names(HAARTstartdate)<-c("site.patient","FirstHAARTdate","FirstHAARTARVclass","FirstHAART")

	HAARTstartdate$FirstHAARTARVclass<-toupper(HAARTstartdate$FirstHAARTARVclass)
	HAARTstartdate$FirstHAARTARVclass<-with(HAARTstartdate, 
										as.factor(ifelse(FirstHAARTARVclass=="NNRTI","NNRTI",
													ifelse(FirstHAARTARVclass=="BOOSTED PI","BOOSTED PI",
													ifelse(FirstHAARTARVclass=="3 NRTI","3 NRTI",
													ifelse(FirstHAARTARVclass=="UNBOOSTED PI","UNBOOSTED PI",
													ifelse(FirstHAARTARVclass=="PI","UNBOOSTED PI",
													ifelse(FirstHAARTARVclass=="OTHER","OTHER",
													ifelse(FirstHAARTARVclass %in% c("NONHAART","NON HAART","NON-HAART"),"nonHAART",
													NA)))))))))

	art<-merge(art,HAARTstartdate,by=c("site.patient"),all=T)


	#Find Time of First Stop
	Artstopdate <- ddply(art[art$startdate==art$FirstARTdate,], .(site.patient), summarize,HAARTFirstStop_dt=min(enddate))
	#Add first end date to art
	art<-merge(art,Artstopdate,by.x=c("site.patient"),by.y=c("site.patient"))

	#Find Time of First Change + New Regimen
	Artchangedate <- ddply(art[art$startdate >= art$HAARTFirstStop_dt & art$FirstART!=art$art_id,], .(site.patient), summarize,HAARTFirstChange_dt=min(startdate))
	Artchangedate<-merge(Artchangedate,art[,c("site.patient","startdate","art_id")],by.x=c("site.patient","HAARTFirstChange_dt"),by.y=c("site.patient","startdate"))
	colnames(Artchangedate)<-c("site.patient","HAARTFirstChange_dt","NewART")


	Artstartstop<-merge(Artstartdate,Artstopdate,by="site.patient")
	ARTSummaryData<-merge(Artstartstop,Artchangedate,by=c("site.patient"),all=T)
	
	
	#Final ART dataset (for now)
	ARTSummaryData<-merge(ARTSummaryData,HAARTstartdate,by="site.patient",all=T)



#############
####Labs#####
#############	
###########################
#Check for first CD4 count
############################
	lab_temp<-merge(lab_cd4,HAARTstartdate,by="site.patient")
	lab_temp$ART1lag<-lab_temp$cd4_dt-lab_temp$FirstHAARTdate

#Nadir CD4 (08SEP2013 addition)
#Does not place lower bound on CD4 date
	lab_temp_t<-lab_temp[lab_temp$ART1lag<=7 & is.na(lab_temp$cd4_v)==F & is.na(lab_temp$ART1lag)==F,]
	nadirCD4data<-ddply(lab_temp_t,.(site.patient), summarize, nadirCD4=min(cd4_v), nadirCD4_lag=max(ART1lag[cd4_v==min(cd4_v)]),nadirCD4_dt=max(cd4_dt[cd4_v==min(cd4_v)]))


#Time since initiation
#Restrict to those labs within baseline CD4 window  -180 - +7 days within initiation
	lab_temp2<-lab_temp_t[lab_temp_t$ART1lag<=7 & lab_temp_t$ART1lag>-181 & is.na(lab_temp_t$ART1lag)==F,]
#How to choose 'best lab:
    #1 - Look for lab closest to start date BEFORE initiation
    #2 - If no lab within 180 days before initiation, take first lab within 7 days
#Create garbo variable to make this happen
#Take abs value of all variables, add 180 days to labs after initiation
#Grab the minimum
	lab_temp2$cd4window_temp<-as.numeric(abs(lab_temp2$ART1lag)+((lab_temp2$ART1lag)>0)*180)
	BaselineCD4data<-ddply(lab_temp2,.(site.patient), summarize, BaselineCD4=max(cd4_v[cd4window_temp==min(cd4window_temp)]),BaselineCD4_lag=ART1lag[cd4window_temp==min(cd4window_temp)],BaselineCD4_dt=cd4_dt[cd4window_temp==min(cd4window_temp)])





###########################
#First VL + VL Failure
###########################
#WTD:  It looks like there is inconsistency in identifying VL failures.  Some sites use negative numbers, some will use the exact detection limit/minus 1.
#24JUL2014:  Giganti decided to use below 400.  May want to confirm.
	lab_rna$undetect.vl<-ifelse(lab_rna$rna_v<=400,1,0)


	labrna_temp<-merge(lab_rna[,c("site.patient","rna_dt","rna_v","undetect.vl")],HAARTstartdate[,c("site.patient","FirstHAARTdate")],by="site.patient")
#Sort by patient,lab date
	labrna_temp<-with(labrna_temp,labrna_temp[order(site.patient,rna_dt),])

#Time since initiation
#Restrict to those labs within baseline VL window  -180 - +7 days within initiation
	labrna_temp$ART1lag<-labrna_temp$rna_dt-labrna_temp$FirstHAARTdate
	labrna_temp2<-labrna_temp[labrna_temp$ART1lag<=7 & labrna_temp$ART1lag>-181 & is.na(labrna_temp$ART1lag)==F,]
#How to choose 'best lab:
	#1 - Look for lab closest to start date BEFORE initiation
	#2 - If no lab within 180 days before initiation, take first lab within 7 days
#Create garbo variable to make this happen
#Take abs value of all variables, add 180 days to labs after initiation
#Grab the minimum
	labrna_temp2$rnawindow_temp<-abs(labrna_temp2$ART1lag)+((labrna_temp2$ART1lag)>0)*180
	BaselineVLdata<-ddply(labrna_temp2,.(site.patient), summarize, BaselineVL=max(rna_v[rnawindow_temp==min(rnawindow_temp)]),BaselineVL_lag=ART1lag[rnawindow_temp==min(rnawindow_temp)],BaselineVL_dt=rna_dt[rnawindow_temp==min(rnawindow_temp)],
	BaselineVL.Undetectable=undetect.vl[rnawindow_temp==min(rnawindow_temp)])




#19SEP2014 addition - speed up code by removing all pre-treatment VLs
	labrna_temp<-labrna_temp[labrna_temp$ART1lag>0,]
	labrna_temp<-labrna_temp[is.na(labrna_temp$rna_v)==F & is.na(labrna_temp$rna_dt)==F ,]


#Altered loop such that patient ID comparison occurs outside loop (rather than comparing [i] to [i-1] for each observation)
#Drammatically improves speed
	labrna_temp$PreviousID<-c("NA",as.character(labrna_temp$site.patient[1:(dim(labrna_temp)[1]-1)]))
	labrna_temp$Newobs<-labrna_temp$site.patient!=labrna_temp$PreviousID


#Define VL Failure
	VLFailure<-rep("",dim(labrna_temp)[1])
	VLEverBelow400<-0
	VLAbove400Consecutive<-0
	for (i in 1:dim(labrna_temp)[1]){
	    if (labrna_temp$Newobs[i]==TRUE){
	        VLFailure[i]<-""
	        VLEverBelow400<-0
	        VLAbove400Consecutive<-0
	    }
    
	    else VLFailure[i]<-VLFailure[i-1]
    
	    if (VLFailure[i]==""){
	        if (labrna_temp$rna_v[i]<=400) {
	            VLEverBelow400<-1
	            VLAbove400Consecutive<-0
	        }
	        else if (labrna_temp$rna_v[i]>400 & VLEverBelow400==0  & labrna_temp$ART1lag[i]>180) VLFailure[i]<-"Definition 1"
	        else if (labrna_temp$rna_v[i]>1000& VLEverBelow400==1 ) VLFailure[i]<-"Definition 3"
	        else if (labrna_temp$rna_v[i]>400 & VLEverBelow400==1 ) {
	            VLAbove400Consecutive<-1+VLAbove400Consecutive
	            if (VLAbove400Consecutive==2) VLFailure[i]<-"Definition 2"
	        }
        
	    }
	}

#For the patients with a failure, find the first instance
	labrna_temp$VLFailure<-VLFailure
	labrna_justfailures<-labrna_temp[labrna_temp$VLFailure!="" ,]
	TimetoFailureData_temp1<-ddply(labrna_justfailures,.(site.patient), summarize, VLFailure=VLFailure[ART1lag==min(ART1lag)],VLFailure_time=ART1lag[ART1lag==min(ART1lag)],VLFailure_dt=rna_dt[ART1lag==min(ART1lag)])

#For those without a failure who had a VL after starting ART, find the time of the last measurement
	labrna_lastobs<-labrna_temp[labrna_temp$ART1lag>0 & is.na(labrna_temp$rna_v)==F & is.na(labrna_temp$ART1lag)==F,]
	labrna_lastobs2<-ddply(labrna_lastobs,.(site.patient), summarize, VLFailure=VLFailure[ART1lag==max(ART1lag)],VLFailure_time=ART1lag[ART1lag==max(ART1lag)],VLFailure_dt=rna_dt[ART1lag==max(ART1lag)])
	TimetoNonFailureData<-labrna_lastobs2[labrna_lastobs2$VLFailure=="",]
	TimetoNonFailureData$VLFailure<-"No Failure"

	TimetoFailureData<-rbind(TimetoFailureData_temp1,TimetoNonFailureData)
                     
                                        
                                            	
###############################################################################
###############################################################################
#Begin process of merging seperate datasets together to create analysis dataset
#R only allows merging one at a time
###############################################################################
###############################################################################

#	temp1<-basic[,c("site.patient","patient","site","center","male","mode","birth_dt","baseline_dt","aids_y","aids_cl_y","recart_y")]
    temp1<-basic[,c("site.patient","patient","site","male","mode","birth_dt","baseline_dt","aids_y","aids_cl_y","recart_y")]  ## Removed center for now (2016-03-29)
    temp2<-merge(temp1,ARTSummaryData,by="site.patient",all=T)
	temp3<-merge(temp2,BaselineCD4data,by="site.patient",all=T)
	temp4<-merge(temp3,nadirCD4data,by="site.patient",all=T)
	temp5<-merge(temp4,follow.short,by="site.patient",all=T)
	temp6<-merge(temp5,BaselineVLdata,by="site.patient",all=T)
	temp7<-merge(temp6,TimetoFailureData,by="site.patient",all=T)
	temp8<-merge(temp7,AIDSstatus,by=c("site.patient","site","patient"),all=T)
	Preliminary<-temp8


#Create analysis variables
#age at ART initiation
	Preliminary$age<-as.numeric(floor((Preliminary$FirstHAARTdate-Preliminary$birth_dt)/365.25))


#Convert Baseline VLs to log scale
#Be very cautious with this variable.   Most undetectables are coded as "- xx", so the absolute values are intended to remove these negatives.  By taking the absolute value (and then the log10), we mask this.   Currently, this does not impact the median/IQR values but should be monitored.
	Preliminary$BaselinelogVL<-log10(abs(Preliminary$BaselineVL))
	Preliminary$nadirCD4cat<-with(Preliminary,ifelse(nadirCD4<=200 & is.na(nadirCD4)==F,"LT 200",
	                            ifelse(nadirCD4>200 & abs(nadirCD4_lag)<=180 & is.na(nadirCD4)==F & is.na(nadirCD4_lag)==F,"GT 200",
	                            "Unknown")))
                                  
	Preliminary$aids.initiation<-ifelse(Preliminary$preARTAIDS.clinical=="AIDS",1,ifelse(Preliminary$preARTAIDS.clinical=="not AIDS",0,NA))
	Preliminary$aids.initiation.all<-ifelse(Preliminary$preARTAIDS.all=="AIDS",1,ifelse(Preliminary$preARTAIDS.all=="not AIDS",0,NA))


	Preliminary$followup.time<-as.numeric(Preliminary$censor_dt-Preliminary$FirstHAARTdate)



	Preliminary$HAARTFirstStop<-with(Preliminary,
									ifelse(is.na(censor_dt)==F & is.na(HAARTFirstStop_dt)==F & censor_dt==HAARTFirstStop_dt &
										is.na(HAARTFirstChange_dt)==F & (HAARTFirstChange_dt)==censor_dt,1,
									ifelse(is.na(censor_dt)==F & is.na(HAARTFirstStop_dt)==F & censor_dt==HAARTFirstStop_dt &
										is.na(HAARTFirstChange_dt)==T,0,
									ifelse(is.na(censor_dt)==F & is.na(HAARTFirstStop_dt)==F & censor_dt>HAARTFirstStop_dt,1,
									ifelse(is.na(censor_dt)==F & is.na(HAARTFirstStop_dt)==F & censor_dt<HAARTFirstStop_dt,99,0)))))

	Preliminary$HAARTFirstStop_dt<-as.Date(with(Preliminary,ifelse(HAARTFirstStop==0,censor_dt,HAARTFirstStop_dt)),origin="1970-01-01")
#Note:  Analysis is restricted to 2000-2012.  Censor patients if HAARTStopDate after 2012
	Preliminary$HAARTFirstStop<-with(Preliminary,ifelse(is.na(HAARTFirstStop_dt)==F & HAARTFirstStop_dt>"2012-12-31",0,HAARTFirstStop))
	Preliminary$HAARTFirstStop_dt<-as.Date(with(Preliminary,ifelse(is.na(HAARTFirstStop_dt)==F & HAARTFirstStop_dt>"2012-12-31","2012-12-31",as.character(HAARTFirstStop_dt))))
	Preliminary$HAARTFirstStop_time<-as.numeric(Preliminary$HAARTFirstStop_dt-Preliminary$FirstHAARTdate)




	Preliminary$HAARTFirstChange<-with(Preliminary,ifelse(is.na(HAARTFirstChange_dt)==T,0,1))
	Preliminary$HAARTFirstChange_dt<-as.Date(with(Preliminary,ifelse(is.na(HAARTFirstChange_dt)==T,censor_dt ,HAARTFirstChange_dt)),origin="1970-01-01")
#Note:  Analysis is restricted to 2000-2012.  Censor patients if HAARTStopDate after 2012
	Preliminary$HAARTFirstChange<-with(Preliminary,ifelse(is.na(HAARTFirstChange_dt)==F & HAARTFirstChange_dt>"2012-12-31",0,HAARTFirstChange))
	Preliminary$HAARTFirstChange_dt<-as.Date(with(Preliminary,ifelse(is.na(HAARTFirstChange_dt)==F & HAARTFirstChange_dt>"2012-12-31","2012-12-31",as.character(HAARTFirstChange_dt))))
	Preliminary$HAARTFirstChange_time<-as.numeric(Preliminary$HAARTFirstChange_dt-Preliminary$FirstHAARTdate)




	Preliminary$Initiation.Year<-as.numeric(format(Preliminary$FirstHAARTdate, "%Y"))


	Preliminary$modetransmission<-as.factor(with(Preliminary,ifelse(mode=="Heterosexual contact", "Heterosexual",
                                   ifelse(mode=="Homosexual contact"|mode=="Bisexual","Homosexual/Bisexual",
                                   ifelse(mode=="Injecting drug user", "IDU",
                                   ifelse(mode=="Homo/Bisexual and Injecting drug user", "IDU",
                                   ifelse(mode=="Heterosexual contact and Injecting drug user","IDU",
                                   ifelse(mode=="Transfusion nonhemophilia related","Other",
                                   ifelse(mode=="Perinatal" |mode=="Hemophiliac", "Other",
                                   ifelse(mode=="Other (specify in mode_oth)","Other",
                                   ifelse(mode=="Unknown","Unknown",
                                   as.character(mode))))))))))))
                                    
	Preliminary$VLFailure<-with(Preliminary,ifelse(VLFailure=="No Failure",0,
                                        ifelse(VLFailure %in% c("Definition 1","Definition 2","Definition 3"),1,NA)))

	Preliminary$VLFailure_time<-as.numeric(Preliminary$VLFailure_time)


#Compare the patients HAART start date versus their ART start date
#The recart variable typically signifies non-naive
#Here, we classify the patient as non-naive if their first art dispensation was non-HAART
	Preliminary$recart_artdata<-with(Preliminary,ifelse(is.na(FirstARTdate), NA,
												ifelse(is.na(FirstHAARTdate),99,
												ifelse(FirstARTdate == FirstHAARTdate, 0,
												ifelse(FirstARTdate != FirstHAARTdate,1, -9)))))

#Sensitivity analysis
#Exclude patients who do not have HAART regimen before freeze date AND are non-naive
	Preliminary$naive<-with(Preliminary,    ifelse(recart_y==0 & recart_artdata==0,1,
											ifelse(recart_y==1 |recart_y==9| recart_artdata==1,0,NA)))
#Save original recart_y values for internal investigations
	Preliminary$recart_y_orig<-Preliminary$recart_y
	Preliminary$recart_y<- with(Preliminary,ifelse(recart_artdata==1,1,recart_y))

#Various exclusions
#Exclude patients who do not have a HAART regimen before freeze date
#Exclude patients less than 18
#Exclude patients from Peru
	Preliminary$Exclusion<-
		with(Preliminary,
	            ifelse(site=="peru","(0): Peru",
	            ifelse(is.na(FirstHAARTdate),"(-1): No ART data",
	            ifelse(is.na(age)==T |Preliminary$birth_dt=="1900-01-01", "(2a): no age info",
	            ifelse(age<18 , "(2b): Age < 18",
	            ifelse(followup.time<0 | is.na(followup.time)==T, "(99): Invalid follow-up time",
	            ifelse(FirstHAARTdate>=as.Date(FreezeDate),"(3): ART start post 2004",
	            ifelse(FirstHAARTdate<as.Date(EarliestARTDate),"(4): ART start before 1996",
	            NA))))))))





#Analysis dataset
	CCASAnet_Analysis<-Preliminary[is.na(Preliminary$Exclusion),]

#Need to rename ARVclass variable so that it represents first HAART class

## removed center (2016-03-29)
#	CCASAnet_Analysis<-CCASAnet_Analysis[,c("site.patient","site","center","male","age","modetransmission","aids.initiation","aids.initiation.all","FirstHAARTARVclass","NRTI","NNRTI","PI","OTHER","BaselineCD4","nadirCD4","BaselinelogVL","BaselineVL.Undetectable","Initiation.Year","followup.time","death_y", "FirstHAARTdate","BaselineCD4_dt","nadirCD4_dt","censor_dt","VLFailure","VLFailure_time","VLFailure_dt","HAARTFirstStop","HAARTFirstStop_dt","HAARTFirstStop_time","HAARTFirstChange","HAARTFirstChange_dt","HAARTFirstChange_time","recart_y","naive")]
#	colnames(CCASAnet_Analysis)<-c("site.patient","site","center","male","age","modetransmission","aids.initiation","aids.initiation.all","ARVclass","NRTI","NNRTI","PI","OTHER","BaselineCD4","nadirCD4","BaselinelogVL","BaselineVL.Undetectable","Initiation.Year","followup.time","DEATH_Y", "FirstHAARTdate","BaselineCD4_dt","nadirCD4_dt","censor_dt","VLFailure","VLFailure_time","VLFailure_dt","HAARTFirstStop","HAARTFirstStop_dt","HAARTFirstStop_time","HAARTFirstChange","HAARTFirstChange_dt","HAARTFirstChange_time","recart_y","naive")
    CCASAnet_Analysis<-CCASAnet_Analysis[,c("site.patient","site","male","age","modetransmission","aids.initiation","aids.initiation.all","ARVclass","NRTI","NNRTI","PI","OTHER","BaselineCD4","nadirCD4","BaselinelogVL","BaselineVL.Undetectable","Initiation.Year","followup.time","death_y", "FirstHAARTdate","BaselineCD4_dt","nadirCD4_dt","censor_dt","VLFailure","VLFailure_time","VLFailure_dt","HAARTFirstStop","HAARTFirstStop_dt","HAARTFirstStop_time","HAARTFirstChange","HAARTFirstChange_dt","HAARTFirstChange_time","recart_y","naive")]
    colnames(CCASAnet_Analysis)<-c("site.patient","site","male","age","modetransmission","aids.initiation","aids.initiation.all","ARVclass","NRTI","NNRTI","PI","OTHER","BaselineCD4","nadirCD4","BaselinelogVL","BaselineVL.Undetectable","Initiation.Year","followup.time","DEATH_Y", "FirstHAARTdate","BaselineCD4_dt","nadirCD4_dt","censor_dt","VLFailure","VLFailure_time","VLFailure_dt","HAARTFirstStop","HAARTFirstStop_dt","HAARTFirstStop_time","HAARTFirstChange","HAARTFirstChange_dt","HAARTFirstChange_time","recart_y","naive")


#	save(CCASAnet_Analysis,file="/Users/giganti/Documents/CCASAnet/FirstWave/FirstWaveDataCCASAnet.Rda")
    save(CCASAnet_Analysis,file="FirstWaveDataCCASAnet.Rda")

rm(temp1,temp2,temp3,temp4,temp5,temp6,temp7,temp8,ARV1,ARV2,ARV3,ARV4,ARV5,ARV6,ARV7,ARV8,NRTI,NNRTI,PI,OTHER,EI,FI,II)
	rm(labrna_temp,labrna_temp2,labrna_lastobs,labrna_lastobs2,labrna_justfailures)
	rm(lab_temp,lab_temp2,lab_temp_t)
	rm(temp_aids_cl_dt,temp_aids_dt,temp_death_dt,HAART_temp)
	rm(art_temp,art_HAARTonly,Artstartstop,Artchangedate,Artstopdate,Artstartdate,HAARTstartdate,ARTSummaryData)
	rm(BaselineCD4data,nadirCD4data,OneMat,ARVreclassification,ARVs,AIDSstatus)
	rm(TimetoFailureData_temp1,TimetoNonFailureData, TimetoFailureData)
	rm(BaselineVLdata,VLFailure,VLAbove400Consecutive,VLEverBelow400)
	rm(Preliminary)
	rm(i)
	#require(gdata)
	#keep(HAARTstartdate,CCASAnet_Analysis,basic,art,visit,follow,lab_cd4,lab_rna,sure=TRUE)



